/** \file     TComEM_JEG.h
    \brief    EM_JEG decoder modification class (header) to consider data loss while decoding frames.

 *
 * Decoder modifications to consider data loss while decoding frames. Source code compatible with HM 12.1
 * Author: Enrico Masala <masala@polito.it>, Politecnico di Torino, Feb 9, 2014
 *
 * Disclaimer:
 * This software is meant to be a prototype only, it is not optimized or fitted to any purposes.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 *
 * Citing this work:
 * We kindly ask people using this code in their research activity
 * to cite the research papers explaining the logic behind this code.
 * More information at: http://media.polito.it/jeg

*/

#ifndef __TCOMEM_JEG__
#define __TCOMEM_JEG__


//#define MAX_MB_NUM ((11*4)*(9*4))
// FullHD  1920*1080 = 120*68(67.5)= 8160 MB
// UltraHD  3840*2160 = 240*135 = 32400 MB 
#define MAX_CU_NUM 32400


//! \ingroup TLibCommon
//! \{

// ====================================================================================================================
// Class definition
// ====================================================================================================================


class TComEM_JEG
{
private:
  int isCUConcealed[MAX_CU_NUM];
  
public:
  TComEM_JEG();
  virtual ~TComEM_JEG();
  
  void init    ();
  void create  ();
  void destroy ();

  int EM_JEG_isCUConcealed(int idx);
  void EM_JEG_setCUConcealed(int cu_address);
  void EM_JEG_resetCUConcealed(void);

};

//! \}

#endif

